{$APPTYPE CONSOLE}
program discrete_logarythm;

type longnum = record
  mant: array[0..400] of longint;
  len: longint;
end;

var d: array[0..4000] of longnum;
    n, i, j, b: longint;
    rem, tempi, cd: longint;
    tempstr: string;
    zero, x: longnum;
    lb, rb, mb, bigrb: longint;

function comp (apar, bpar: longnum): integer;
var il: integer;
begin
  if apar.len > bpar.len then il := apar.len - 1 else il := bpar.len - 1;
  while (il >= 0) and (apar.mant[il] = bpar.mant[il]) do dec(il);
  if il >= 0 then result := apar.mant[il] - bpar.mant[il]
             else result := 0;
end;

begin
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);

  for i := 0 to 400 do zero.mant[i] := 0;
  zero.len := 0;

  readln (n); readln (b);

  i := 0;
  d[0].mant[0] := 1;
  d[0].len := 1;

  while 3*(d[i].len - 1) <= 1000 do
  begin
    inc(i);
    for j := 0 to (d[i-1].len - 1) do d[i].mant[j] := b*(d[i-1].mant[j]);
    rem := 0; j := 0;
    repeat
      tempi := d[i].mant[j] + rem;
      rem := tempi div 1000;
      d[i].mant[j] := tempi mod 1000;
      inc(j);
    until (rem = 0) and (j > (d[i-1].len - 1));
    d[i].len := j;
  end;
  bigrb := i;

  for j := 1 to n do
  begin
    readln (tempstr);
    while (length(tempstr) mod 3) <> 0 do tempstr := '0' + tempstr;
    x := zero;
    for i := 0 to ((length(tempstr) div 3) - 1) do
      val (copy(tempstr, length(tempstr) - 3*i - 2, 3), x.mant[i], cd);
    x.len := (length(tempstr) div 3);

    lb := 0; rb := bigrb;
    if comp(x, d[rb]) > 0 then lb := rb
    else
    begin
      while rb - lb > 1 do
      begin
        mb := (lb + rb) div 2;
        if comp(x, d[mb]) > 0 then lb := mb
        else if comp (x, d[mb]) < 0 then rb := mb - 1
        else if comp (x, d[mb]) = 0 then begin lb := mb; rb := mb; end;
      end;
      if comp(x, d[rb]) >= 0 then lb := rb;
    end;
    writeln (lb);
  end;
  close (output);
end.